//--------------------------------------------------------------------------
//
//  Tetris Unlimited
//  Copyright (C) 2001-2003  Oscar Giner Martnez
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//--------------------------------------------------------------------------


#define EST_GAMEOVER		1
#define EST_ANIM_LINEAS		2
#define EST_TIMEOUT			3

void initialize_mini_score(t_mini_score_list& sc_list);
void initialize_stats(t_stats& stats);
void GetAngleForSpline(int points[8], int npts, float *a, float *v);
void pause_effect (BITMAP *fondo);
void show_stats(t_juego *juego, int *win_lose_array);
void add_mini_score(t_mini_score_list *sc_list, int posx, int posy, int score, int color);
void mini_score_siguiente_paso(t_mini_score_list *sc_list);
void dibujar_mini_score(BITMAP *dest, t_mini_score_list *sc_list);
bool tablero_vacio(t_tablero *tab);
int se_puede_mover(t_set_piezas *piezas, int num_pieza, int pieza_pos_x, int pieza_pos_y, int pieza_rot, t_tablero *tab);
int colisiona_con_pieza(t_jug* jug, t_set_piezas *piezas, int num_pieza, int pieza_pos_x, int pieza_pos_y, int pieza_rot, t_juego* juego, t_tablero *tab);
int colocar_pieza(t_tablero* tab, t_set_piezas *piezas, int pieza, int pieza_pos_x, int pieza_pos_y, int pieza_rot);
void dibujar_tablero(BITMAP* dest, t_tablero* tab, t_set_piezas* piezas, BITMAP *graf_piezas);
void dibujar_pieza(BITMAP* dest, int posx, int posy, t_set_piezas *piezas, BITMAP *graf_piezas, int pieza, int pieza_rot=0);
void dibujar_pieza(BITMAP* dest, t_jug& ju);
void eliminar_lineas(t_tablero *tab, int *linea, int num);
void insertar_linea(t_tablero *tab, char num);
void penalizar(t_juego* juego, t_tablero *tab, int lineas);
int comprobar_lineas(t_juego *juego, t_jug *jug);
unsigned short primera_fila_no_libre(const t_pieza &pieza_rot, const signed char pieza[16]);
unsigned short ultima_fila_no_libre(const t_pieza &pieza_rot, const signed char pieza[16]);
