//--------------------------------------------------------------------------
//
//  Tetris Unlimited
//  Copyright (C) 2001-2003  Oscar Giner Martnez
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//--------------------------------------------------------------------------


#include "stdafx.h"

#include "defines.h"
#include "consola.h"
#include "editor.h"
#include "jugador.h"
#include "sis_part.h"
#include "musica.h"
#include "Video.h"
#include "main.h"

ALTEXT_Translation *altext_language=NULL;

int fullscreen;
int coldepth;
int res_x, res_y;
int refresh_mode;
int disable_hw_accel;

int volfx;
int volmus;
int digi_driver_id;

string path_data;
string path_music;
string path_players;
string path_pieces;
string path_text;
string path_backgrounds;

BITMAP *flecha[60];
BITMAP *brillo_bmp;

t_consola *consola_main;
t_consola* consola;

controles control_p1, control_p2, control_p3, control_p4;

DATAFILE* cur_music = NULL;
t_musica music[MAX_MUSICA];

int num_canciones;

DATAFILE *fuente;

FONT *roman;
FONT *menu;
FONT *book;
FONT *roman12;
FONT *comic16;
FONT *amelia;
FONT *small_font;
//ALFONT_FONT *alfont_comic16;

FSOUND_SAMPLE *sound_menu_trans;
FSOUND_SAMPLE *sound_tick;
FSOUND_SAMPLE *sound_colocar_pieza;
FSOUND_SAMPLE *sound_girar_pieza;
FSOUND_SAMPLE *sound_linea;
FSOUND_SAMPLE *sound_tetris;

FSOUND_STREAM* fmod_music_stream;
FMUSIC_MODULE* fmod_music_module;

int cur_music_type = -1;
int act_musica_grupo;
int act_musica_num;

BITMAP *buffer;

volatile int counter;

char part_qual;

t_set_piezas set_piezas[MAX_SETS];
int num_sets_piezas;

unsigned int num_jug;
struct t_jugador jugador[MAX_JUGADORES];

struct t_jugador jugador_anonimo;

Video video;

/*
#define MI 3

char scancode_name[MI][128][15] =
{
	{
		"(nada)",    "A",          "B",          "C",
		"D",         "E",          "F",          "G",
		"H",         "I",          "J",          "K",
		"L",         "M",          "N",          "O",
		"P",         "Q",          "R",          "S",
		"T",         "U",          "V",          "W",
		"X",         "Y",          "Z",          "0",
		"1",         "2",          "3",          "4",
		"5",         "6",          "7",          "8",
		"9",         "0_PAD",      "1_PAD",      "2_PAD",
		"3_PAD",     "4_PAD",      "5_PAD",      "6_PAD",
		"7_PAD",     "8_PAD",      "9_PAD",      "F1",
		"F2",        "F3",         "F4",         "F5",
		"F6",        "F7",         "F8",         "F9",
		"F10",       "F11",        "F12",        "ESC",
		"",         "'",          "",          "RETROCESO",
		"TAB",       "`",          "+",          "ENTER",
		"",	     "",          "",          "<",
		",",         ".",          "-",          "ESPACIO",
		"INSERTAR",  "SUPRIMIR",   "INICIO",     "FIN",
		"RE PG",    "AV PG",     "IZQUIERDA",  "DERECHA",
		"ARRIBA",    "ABAJO",      "/",          "*",
		"- PAD",     "+ PAD",      "SUPR_PAD",   "ENTER_PAD",
		"IMPR PANT", "?? 0x5d",    "?? 0x5e",    "?? 0x5f",
		"?? 0x60",   "?? 0x61",    "?? 0x62",    "?? 0x63",
		"?? 0x64",   "?? 0x65",    "?? 0x66",    "LSHIFT",
		"RSHIFT",    "LCONTROL",   "RCONTROL",   "ALT",
		"ALTGR",     "?? 0x6d",    "?? 0x6e",    "?? 0x6f",
		"BLOQ DESPL","BLOQ NUM",   "BLOQ MAYS", "?? 0x73",
		"?? 0x74",   "?? 0x75",    "?? 0x76",    "?? 0x77",
		"?? 0x78",   "?? 0x79",    "?? 0x7a",    "?? 0x7b",
		"?? 0x7c",   "?? 0x7d",    "?? 0x7e",    "?? 0x7f",
	},
	{
		"(res)",     "A",          "B",          "C",
		"D",         "E",          "F",          "G",
		"H",         "I",          "J",          "K",
		"L",         "M",          "N",          "O",
		"P",         "Q",          "R",          "S",
		"T",         "U",          "V",          "W",
		"X",         "Y",          "Z",          "0",
		"1",         "2",          "3",          "4",
		"5",         "6",          "7",          "8",
		"9",         "0_PAD",      "1_PAD",      "2_PAD",
		"3_PAD",     "4_PAD",      "5_PAD",      "6_PAD",
		"7_PAD",     "8_PAD",      "9_PAD",      "F1",
		"F2",        "F3",         "F4",         "F5",
		"F6",        "F7",         "F8",         "F9",
		"F10",       "F11",        "F12",        "ESC",
		"",         "'",          "",          "RETROCS",
		"TAB",       "`",          "+",          "ENTER",
		"",         "",          "",          "<",
		",",         ".",          "-",          "ESPAI",
		"INSERTAR",  "SUPRIMIR",   "INICI",      "FI",
		"RE PG",    "AV PG",     "ESQUERRA",   "DRETA",
		"AMUNT",     "ABAIX",      "/",          "*",
		"- PAD",     "+ PAD",      "SUPR_PAD",   "ENTER_PAD",
		"IMPR PANT", "?? 0x5d",    "?? 0x5e",    "?? 0x5f",
		"?? 0x60",   "?? 0x61",    "?? 0x62",    "?? 0x63",
		"?? 0x64",   "?? 0x65",    "?? 0x66",    "LSHIFT",
		"RSHIFT",    "LCONTROL",   "RCONTROL",   "ALT",
		"ALTGR",     "?? 0x6d",    "?? 0x6e",    "?? 0x6f",
		"BLOQ DEPL", "BLOQ NUM",   "BLOQ MAYS", "?? 0x73",
		"?? 0x74",   "?? 0x75",    "?? 0x76",    "?? 0x77",
		"?? 0x78",   "?? 0x79",    "?? 0x7a",    "?? 0x7b",
		"?? 0x7c",   "?? 0x7d",    "?? 0x7e",    "?? 0x7f",
	},
	{
		"(none)",    "A",          "B",          "C",
		"D",         "E",          "F",          "G",
		"H",         "I",          "J",          "K",
		"L",         "M",          "N",          "O",
		"P",         "Q",          "R",          "S",
		"T",         "U",          "V",          "W",
		"X",         "Y",          "Z",          "0",
		"1",         "2",          "3",          "4",
		"5",         "6",          "7",          "8",
		"9",         "0_PAD",      "1_PAD",      "2_PAD",
		"3_PAD",     "4_PAD",      "5_PAD",      "6_PAD",
		"7_PAD",     "8_PAD",      "9_PAD",      "F1",
		"F2",        "F3",         "F4",         "F5",
		"F6",        "F7",         "F8",         "F9",
		"F10",       "F11",        "F12",        "ESC",
		"TILDE",     "MINUS",      "EQUALS",     "BACKSPACE",
		"TAB",       "OPENBRACE",  "CLOSEBRACE", "ENTER",
		"COLON",     "QUOTE",      "BACKSLASH",  "BACKSLASH2",
		"COMMA",     "STOP",       "SLASH",      "SPACE",
		"INSERT",    "DEL",        "HOME",       "END",
		"PG UP",     "PG DOWN",    "LEFT",       "RIGHT",
		"UP",        "DOWN",       "SLASH_PAD",  "ASTERISK",
		"MINUS_PAD", "PLUS_PAD",   "DEL_PAD",    "ENTER_PAD",
		"PRTSCR",    "?? 0x5d",    "?? 0x5e",    "?? 0x5f",
		"?? 0x60",   "?? 0x61",    "?? 0x62",    "?? 0x63",
		"?? 0x64",   "?? 0x65",    "?? 0x66",    "LSHIFT",
		"RSHIFT",    "LCONTROL",   "RCONTROL",   "ALT",
		"ALTGR",     "?? 0x6d",    "?? 0x6e",    "?? 0x6f",
		"SCRLOCK",   "NUMLOCK",    "CAPSLOCK",   "?? 0x73",
		"?? 0x74",   "?? 0x75",    "?? 0x76",    "?? 0x77",
		"?? 0x78",   "?? 0x79",    "?? 0x7a",    "?? 0x7b",
		"?? 0x7c",   "?? 0x7d",    "?? 0x7e",    "?? 0x7f",
	}
};


char nombre_idioma[MI][20] = {"Espaol", "Catal", "English"};

char no_video_mem[MI][50] = {"", "No hi ha suficient memria de video", "There isn't enought video memory"};

char opcion_no_disponible[MI][60] = {"", "No disponible encara. Vindr en futures versions", "Not available yet. It will come in future versions"};

char error_al_cargar[MI][25] = {"", "Error al carregar", ""};

char creditos_programado_por[MI][25] = {"", "Programat per", ""};
char creditos_graficos[MI][15] = {"", "Grfics", ""};
char creditos_musica[MI][15] = {"", "Msica", ""};
char creditos_versiones_de_musicas_de_rpg[MI][40] = {"", "versions de msiques de RPG d'internet", ""};
char creditos_agradecimientos[MI][25] = {"", "Agraments", ""};
char creditos_y_otra_mucha_gente_por[MI][50] = {"", "y molta gent ms per", ""};
char creditos_por[MI][10] = {"por", "per", ""};
char creditos_si_tienes_alguna_sugerencia_duda_o_problema[MI][60] = {"", "Si tens algun suggeriment, dubte o problema:", ""};

char musica_reproduciendo[MI][20] = {"REPRODUCIENDO", "REPRODUINT", ""};
char musica_grupo[MI][10] = {"Grupo", "Grup", ""};
char musica_nombre[MI][10] = {"Nombre", "Nom", ""};

char no_hay_ningun_set_piezas[MI][40] = {"", "No hi ha cap set de pees", ""};
char error_abrir_archivo_graficos[MI][50] = {"", "Error al obrir l'arxiu de grfics", ""};
char no_hay_ningun_archivo_graficos[MI][45] = {"", "No hi hs cap arxiu de grfics", ""};
char nombre_set_piezas[MI][30] = {"", "Nom del set de pees:", ""};
char nombre_archivo[MI][25] = {"", "Nom de l'arxiu:", ""};
char error_guardar_set_en_el_archivo[MI][40] = {"", "Error al guardar el set en l'arxiu", ""};
char se_ha_guardado_set_en_archivo[MI][40] = {"", "S'ha guardat el set a l'arxiu", ""};
char numero_piezas[MI][20] = {"", "Nombre de pees", ""};
char probabilidades[MI][20] = {"", "Probabilitats", ""};
char menu_guardar[MI][10] = {"", "Guardar", ""};

char arriba[MI][15] = {"", "Adalt", ""};
char abajo[MI][15] = {"", "Abaix", ""};
char izquierda[MI][15] = {"", "Esquerra", ""};
char derecha[MI][15] = {"", "Dreta", ""};

char aceptar[MI][10] = {"", "Aceptar", ""};
char cancelar[MI][15] = {"", "Cancellar", ""};
char si[MI][6] = {"", "Si", ""};
char no[MI][6] = {"", "No", ""};

char juego_nuevo[MI][20] = {"", "Nou Joc", ""};
char jugadores[MI][15] = {"", "Jugadors", ""};
char records[MI][20] = {"", "Veure Rcords", ""};
char opciones[MI][20] = {"", "Opcions", ""};
char extras[MI][15] = {"", "Extres", ""};
char creditos[MI][15] = {"", "Crdits", ""};
char salir[MI][15] = {"", "Sortir", ""};

char volver[MI][10] = {"", "Tornar", ""};

char arcade[MI][15] = {"", "Arcade", ""};
char normal[MI][20] = {"", "Normal", ""};
char cooperativo[MI][30] = {"", "Cooperatiu", ""};
char competitivo[MI][30] = {"", "Competitiu", ""};
char survival[MI][20] = {"", "Survival", ""};
char campeonato[MI][30] = {"", "Campionat", ""};

char nuevo_jug[MI][20] = {" ", "Nou Jugador", ""};
char eliminar_jug[MI][20] = {"", "Eliminar Jugador", ""};
char info_jug[MI][20] = {"", "Veure Informaci", ""};
char importar_jug[MI][25] = {"", "Importar Jugador", ""};
char exportar_jug[MI][25] = {"", "Exportar Jugador", ""};

char opciones_tit[MI][15] = {"", "Opcions", ""};
char opc_idioma[MI][20] = {"", "Idioma", ""};
char opc_volfx[MI][25] = {"", "Volum FX", ""};
char opc_volmus[MI][25] = {"Vol. MIDI, "Vol. MIDI", ""};
char opc_ctrl_jug[MI][30] = {"", "Controls jugador %d", ""};

char ext_galeria[MI][15] = {"", "Galleria", ""};
char ext_musica[MI][15] = {"", "Msica", ""};
char ext_editorpiezas[MI][25] = {"", "Editor de peces", ""};

char introduce_nombre[MI][35] = {"", "Introdueix el teu nom: ", " "};
char introduce_apellido[MI][35] = {"", "Introdueix el teu cognom: ", " "};
char introduce_nick[MI][25] = {"", "Introdueix el teu nick: ", " "};

char q_eliminar_jugador[MI][75] = {"", "Segur que vols eliminar el jugador", ""};
char q_eliminar_records[MI][75] = {"", "Vols eliminar tots els rcords d'aquest jugador?", ""};
char q_no_hay_ningun_jug[MI][25] = {"", "No hi ha cap jugador", ""};
char q_no_hay_jugadores_1[MI][80] = {"No hay ningn jugador. Debes crear al menos uno. Para ello", "No hi ha cap jugador. Has de crear al menys un. Per aix", "There isn't any player. You must add one. To do it, "};
char q_no_hay_jugadores_2[MI][80] = {"ve al men 'Jugadores' y pulsa ENTER sobre 'Nuevo Jugador'", "ves al men 'Jugadors' i prem ENTER sobre 'Nou Jugador'", "go to 'Players' menu and press ENTER in 'New Player'"};
char q_nombre_archivo[MI][25] = {"Nombre del archivo: ", "Nom de l'archiu: ", " "};
char se_ha_guardado_el_jugador_en_el_archivo[MI][50] ={"", "S'ha guardat el jugador a l'arxiu", ""};
char jugador_ya_existe[MI][35] = {"", "El jugador ja existeix", ""};
char no_hay_ningun_archivo_para_importar[MI][50] = {"", "No hi ha cap arxiu per importar", ""};
char no_se_ha_podido_importar_el_jugador[MI][50] = {".", "No s'ha pogut importar el jugador", "."};
char el_archivo_puede_estar_danado_o[MI][50] = {"El archivo puede estar daado o", "L'arxiu pot estar danyat o", "The file may be corrupted or"};
char ser_de_una_version_diferente[MI][40] = {"ser de una versin diferente.", "sser d'una versi diferent.", "it can be from a different version."};

char cargando_musica[MI][30] = {"", "Carregant msica", ""};

char n_jugador[MI][20] = {"jugador", "jugador", "player"};
char n_jugadores[MI][20] = {"jugadores", "jugadors", "players"};
char no_reg_suficientes_jug[MI][50] = {"No hay registrados suficientes jugadores", "No hi ha suficients jugadors registrats", "Not enought players registered"};

char PUNTOS[MI][15] = {"", "PUNTS", ""};
char LINEAS[MI][15] = {"", "LINIES", ""};
char NIVEL[MI][15] = {"", "NIVELL", ""};
char puntos[MI][15] = {"", "Punts", ""};
char lineas[MI][15] = {"", "Linies", ""};
char nivel[MI][15] = {"", "Nivell", ""};
char ganadas[MI][20] = {"", "Guanyades", ""};
char perdidas[MI][20] = {"", "Perdudes", ""};
char empatadas[MI][25] = {"", "Empatades", ""};
char partidas_multijugador[MI][50] = {"", "Partides Multijugador", ""};
char companero[MI][20] = {"", "Company", ""};
char posicion[MI][15] = {"", "Posici", ""};
char campeonatos_jugados[MI][35] = {"", "Campionats Jugats", ""};
char ganados[MI][20] = {"", "Guanyats", ""};

char pausa[MI][10] = {"", "PAUSA", ""};

char nuevo_set_piezas[MI][30] = {"", "Nou set de peces", ""};
char modif_set_piezas[MI][40] = {"", "Modificar set existent", ""};
*/
