//////////////////////////////////////////////////////////
//                                                      //
//  rand.cpp                                            //
//                                                      //
//  Random number generation class, using the standard  //
//  C library,                                          //
//  by Oscar Giner Martnez                             //
//  o_giner@hotmail.com                                 //
//                                                      //
//  This code is free domain.                           //
//                                                      //
//////////////////////////////////////////////////////////


#include <stdafx.h>
#include "rand.h"

//##ModelId=3FB2144001B5
bool CRand::first_time = true;
//##ModelId=3FB2144001C0
unsigned CRand::global_seed = 0;

//##ModelId=3FB2144001C9
CRand::CRand(void)
{
	initialize();
}

//##ModelId=3FB2144001CB
CRand::CRand(int s)
{
	seed = s;
}

//##ModelId=3FB2144001D4
CRand::CRand(CRand& r)
{
	seed = r.seed;
}

//##ModelId=3FB2144001D6
CRand::~CRand(void)
{
}

//##ModelId=3FB2144001DE
void CRand::initialize(void)
{
	if (first_time)
	{
		global_seed = time(NULL);
		first_time = false;
	}
	else
	{
		global_seed++;
	}
	seed = global_seed;
}

//##ModelId=3FB2144001E0
int CRand::rand(void)
{
	srand(seed);
	seed = ::rand();
	return seed;
}
